/*
 * Copyright (c) 2021 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <stdint.h>

#include "softbus_bus_center.h"

#ifndef LNN_DISCOVERY_MANAGER_H
#define LNN_DISCOVERY_MANAGER_H

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif
#endif

typedef struct {
    void (*OnDeviceFound)(const ConnectionAddr *addr);
} LnnDiscoveryImplCallback;

int32_t LnnInitDiscoveryManager(void);

int32_t LnnStartDiscovery(void);

void LnnStopDiscovery(void);

int32_t __attribute__ ((weak)) LnnInitCoapDiscovery(LnnDiscoveryImplCallback *callback);

int32_t __attribute__ ((weak)) LnnStartCoapDiscovery(void);

int32_t __attribute__ ((weak)) LnnStopCoapDiscovery(void);

#ifdef __cplusplus
#if __cplusplus
}
#endif /* __cplusplus */
#endif /* __cplusplus */

#endif /* LNN_DISCOVERY_MANAGER_H */
