/*
 * Copyright (c) 2021 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "session_callback_mock.h"

#include "SessionDef.h"
#include "session_service_impl.h"

using namespace Communication::SoftBus;

int InnerOnSessionOpened(int sessionId, int result)
{
    SessionServiceImpl sessionImpl;
    return sessionImpl.OpenSessionCallback(sessionId);
}

void InnerOnSessionClosed(int sessionId)
{
    SessionServiceImpl sessionImpl;
    sessionImpl.CloseSessionCallback(sessionId);
}

void InnerOnBytesReceived(int sessionId, const void *data, unsigned int dataLen)
{
    SessionServiceImpl sessionImpl;
    sessionImpl.BytesReceivedCallback(sessionId, data, dataLen);
}

void InnerOnMessageReceived(int sessionId, const void *data, unsigned int dataLen)
{
    SessionServiceImpl sessionImpl;
    sessionImpl.MessageReceivedCallback(sessionId, data, dataLen);
}