#ifndef MOBILESTORAGEVIEWWIDGET_H
#define MOBILESTORAGEVIEWWIDGET_H

#include <QWidget>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QCheckBox>
#include <QLabel>
#include <QPushButton>

#include "mobilestoragelistview.h"
#include "timelinelistwidget.h"

//所有时间线标题和图片
class MobileStorageViewWidget : public QWidget
{
    Q_OBJECT
public:
    MobileStorageViewWidget(const QMap<QString, FileInfo> &listStruct, QWidget *parent = nullptr);

    //设置列表模式
    void setMode(QListView::ViewMode mode);

    void setViewHeight();
public Q_SLOTS:

private Q_SLOTS:
    void slotFileName(QString fileNamePath);
    void slotShowCopyButton();
    void slotHideCopyToComputerWidget();
    void slotSelectDataList(const QList<FileInfo> &fileList);

protected:
    void dragEnterEvent(QDragEnterEvent *event) override;
    void dropEvent(QDropEvent *event) override;

Q_SIGNALS:
    void signalViewModeFlag(QListView::ViewMode mode);
    void sigFileName(QString fileNamePath);
    void sigShowCopyButton();
    void sigHideCopyToComputerWidget();
    void sigSelectDataList(const QList<FileInfo> &fileList);
    void sigLocalPathList(const QStringList &localpath);
    void sigMenuFileName(QString fileName);
    void sigViewHeight();

private:
    void initViewWidget();
    QMap<QString, FileInfo> m_listStruct;

private:
    QList<QString> m_file;
    QString m_path;
};

#endif // MOBILESTORAGEVIEWWIDGET_H
